/******************************************************************************** 
    Desarrollado por:   Avanxo México
    Autor:              Héctor Figueroa
    Proyecto:           TOYOTA TAM
    Descripción:        Clase que contiene la logica para procesar los registros de TAM_InventarioVehiculosToyota__c
                        04-Mayo-2020 se agrega el metodo insertaRegistros

    Infomación de cambios (versiones)
    ===============================================================================
    No.    Fecha                Autor                       Descripcion
    1.0    04-Mayo-2020         Héctor Figueroa             Creación
******************************************************************************* */

public with sharing class TAM_InventarioVehiculosToyotaTgrHandler extends TriggerHandler{

    private List<TAM_InventarioVehiculosToyota__c> inventariosWList;
    private Map<Id,TAM_InventarioVehiculosToyota__c> inventariosWMap;
    
    public TAM_InventarioVehiculosToyotaTgrHandler() {
        this.inventariosWList = Trigger.new;    
        this.inventariosWMap = (Map<Id,TAM_InventarioVehiculosToyota__c>)Trigger.newMap;
    }

    public override void beforeInsert(){
        actualizaVersion(inventariosWList);
    }

    public override void beforeUpdate(){
        actualizaVersion(inventariosWList);
    }

    public override void afterInsert(){
        creaColaboracionDealer(inventariosWList);
        eliminaRecords(inventariosWMap);
        actualizaDod(inventariosWList);
        //cancelaVentaEspacial(inventariosWList);
    }

    public override void afterUpdate(){
        creaColaboracionDealer(inventariosWList);
        actualizaDod(inventariosWList);     
        //cancelaVentaEspacial(inventariosWList);
    }//

    private void eliminaRecords(Map<Id,TAM_InventarioVehiculosToyota__c> mapIW){
        List<TAM_InventarioVehiculosToyota__c> vinesVehicuToyota = new List<TAM_InventarioVehiculosToyota__c>();
        Set<String> setTipoInv = new Set<String>();
        
        //Recorre la lista de reg que vienen en mapIW y toma el campo t.TAM_TipoInventarioLetra__c 
        for (TAM_InventarioVehiculosToyota__c objInvVehPaso : mapIW.values()){
            if (objInvVehPaso.TAM_TipoInventarioLetra__c != null)
                setTipoInv.add(objInvVehPaso.TAM_TipoInventarioLetra__c);
        }//Fin del for mapIW.values()
        System.debug('EN TAM_InventarioVehiculosToyotaTgrHandler.execute setTipoInv: ' + setTipoInv);

        String sLTipoInv = '(';     
        //Recorre la lista de lClientes
        for (String sTipoInv : setTipoInv){
            sLTipoInv += '\'' + sTipoInv + '\',';
        }
        sLTipoInv = sLTipoInv.substring(0, sLTipoInv.lastIndexOf(','));
        sLTipoInv += ')';
        System.debug('EN TAM_InventarioVehiculosToyotaTgrHandler.execute sLTipoInv: ' + sLTipoInv);

        String squery = 'SELECT Id FROM TAM_InventarioVehiculosToyota__c ';
        squery +=  ' WHERE CreatedDate < TODAY And TAM_TipoInventarioLetra__c IN ' + sLTipoInv;
        squery +=  ' Order by CreatedDate ASC LIMIT 200 ';

        if (Test.isRunningTest())
            squery = 'SELECT Id FROM TAM_InventarioVehiculosToyota__c Order by CreatedDate ASC LIMIT 1';
        System.debug('EN TAM_InventarioVehiculosToyotaTgrHandler squery: ' + squery);           
        List<SObject> lSoInveVeicToy = Database.query(squery);
        if (!lSoInveVeicToy.isEmpty()){
            for (SObject objInvTrans : lSoInveVeicToy){
                vinesVehicuToyota.add( (TAM_InventarioVehiculosToyota__c) objInvTrans );
            }
        }//Fin si !lSoInveVeicToy.isEmpty()
        System.debug('EN TAM_InventarioVehiculosToyotaTgrHandler vinesVehicuToyota: ' + vinesVehicuToyota);     
        //Eliminalos
        if (!Test.isRunningTest()){
            //delete vinesVehicuToyota;
            //delete vinesPiso;
            List<Database.Deleteresult> lDtbUpsRes = Database.delete(vinesVehicuToyota, false);
            //Ve si hubo error
            for (Database.Deleteresult objDtbUpsRes : lDtbUpsRes){
                if (!objDtbUpsRes.isSuccess())
                    System.debug('En TAM_InventarioVehiculosToyotaTgrHandler hubo error a la hora de eliminar el reg: ' + objDtbUpsRes.getErrors()[0].getMessage());
            }//Fin del for para lDtbUpsRes
        }
        
        //WHOLE SALE DELETE
        List<InventarioWholesale__c> vinesPiso = new List<InventarioWholesale__c>();
        Map<String, string> mapVinPaso = new map<String, String>();
        set<String> setVinLeadPaso = new set<String>(); 
        
        squery = 'SELECT Id FROM InventarioWholesale__c WHERE CreatedDate < TODAY Order by CreatedDate ASC LIMIT 200';
        if (Test.isRunningTest())
            squery = 'SELECT Id FROM InventarioWholesale__c Order by CreatedDate ASC LIMIT 1';
        System.debug('EN TAM_InventarioVehiculosToyotaTgrHandler squery: ' + squery);           
        List<SObject> lSoInvePiso = Database.query(squery);
        if (!lSoInvePiso.isEmpty()){
            for (SObject objInvPiso : lSoInvePiso){
                vinesPiso.add( (InventarioWholesale__c) objInvPiso );
            }
        }//Fin si !vinesPiso.isEmpty()
        System.debug('EN TAM_InventarioVehiculosToyotaTgrHandler vinesPiso: ' + vinesPiso);     
        //Eliminalos
        if (!Test.isRunningTest()){
            //delete vinesPiso;
            List<Database.Deleteresult> lDtbUpsRes = Database.delete(vinesPiso, false);
            //Ve si hubo error
            for (Database.Deleteresult objDtbUpsRes : lDtbUpsRes){
                if (!objDtbUpsRes.isSuccess())
                    System.debug('En TAM_InventarioVehiculosToyotaTgrHandler el Inventario Wholesale hubo error a la hora de crear/Actualizar: ' + objDtbUpsRes.getErrors()[0].getMessage());
            }//Fin del for para lDtbUpsRes
        }
        //FIN WHOLE SALE DELETE     
        
    }

    public static void actualizaVersion(List<TAM_InventarioVehiculosToyota__c> lstNewClienteVehiculo){
        Set<String> setIdExtMod = new Set<String>();
        Set<String> setIdExtAnio = new Set<String>();
        Map<String, String> mapIdExtObjCatCenMod = new Map<String, String>();
        
        System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler ...');           
        for(TAM_InventarioVehiculosToyota__c objInvenFyG : lstNewClienteVehiculo){
            //Ve si tiene algo el cammpo de Dealer_Code__c
            if (objInvenFyG.Model_Number__c != null && objInvenFyG.Model_Year__c != null){
                setIdExtMod.add(objInvenFyG.Model_Number__c);
                setIdExtAnio.add(objInvenFyG.Model_Year__c);
            }//Fin si objInvenFyG.Model_Number__c != null && objInvenFyG.Model_Year__c != null
        }
        System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler setIdExtMod: ' + setIdExtMod);
        System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler setIdExtAnio: ' + setIdExtAnio);
        
        //Busca la version en el objeto de Select c.Version__c, c.Modelo__c, c.AnioModelo__c From CatalogoCentralizadoModelos__c c
        for (CatalogoCentralizadoModelos__c objCat : [Select c.Version__c, c.Modelo__c, c.AnioModelo__c From CatalogoCentralizadoModelos__c c
            Where (Modelo__c IN :setIdExtMod OR AnioModelo__c IN:setIdExtAnio) And Version__c != null ]){
            //Crea el id externo
            String sIdExt = objCat.Modelo__c + '' + objCat.AnioModelo__c;
            mapIdExtObjCatCenMod.put(sIdExt, objCat.Version__c != NULL ? objCat.Version__c : NULL);
        }
        System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler NO EXISTE mapIdExtObjCatCenMod: ' + mapIdExtObjCatCenMod.KeySet());
        System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler NO EXISTE mapIdExtObjCatCenMod: ' + mapIdExtObjCatCenMod.Values());
        
        //Crea la colaboracion para el reg 
        for(TAM_InventarioVehiculosToyota__c objInvenFyG : lstNewClienteVehiculo){
            if (objInvenFyG.Model_Number__c != null && objInvenFyG.Model_Year__c != null){
                String sIdExt = objInvenFyG.Model_Number__c + '' + objInvenFyG.Model_Year__c;
                objInvenFyG.TAM_Version__c = mapIdExtObjCatCenMod.containsKey(sIdExt) ? mapIdExtObjCatCenMod.get(sIdExt) : null;
            }//Fin objInvenFyG.Model_Number__c != null && objInvenFyG.Model_Year__c != null
            //Actualiza el dato del numero de dias en piso
            if (objInvenFyG.Tipo_Inventario__c == 'Piso'){
                Integer inNoDias = (objInvenFyG.TAM_DiasPiso__c != null && objInvenFyG.TAM_DiasPiso__c != '') ? Integer.valueOf(objInvenFyG.TAM_DiasPiso__c) : 0;
                System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler inNoDias: ' + inNoDias + ' inNoDias2: ' + String.valueOf(inNoDias));
                objInvenFyG.TAM_DiasPiso__c = String.valueOf(inNoDias);
                objInvenFyG.TAM_DEI__c = inNoDias;
            }//Fin si objInvenFyG.TAM_DiasPiso__c != null && objInvenFyG.TAM_DiasPiso__c != ''
            if (objInvenFyG.Tipo_Inventario__c != 'Piso')
               objInvenFyG.TAM_DEI__c = null;            
            System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler NO EXISTE objInvenFyG: ' + objInvenFyG);         
        }
                    
    }

    //After
    public static void creaColaboracionDealer(List<TAM_InventarioVehiculosToyota__c> lstNewClienteVehiculo){
        System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler ...');           
        
        Boolean blnPermiteColaborarInventario = (System.Label.TAM_ColaborarInventario != null && System.Label.TAM_ColaborarInventario != '') 
            ? Boolean.valueOf(System.Label.TAM_ColaborarInventario) : false ;        
        System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler blnPermiteColaborarInventario: ' + blnPermiteColaborarInventario);           
        
        Set<String> setVodDealer = new Set<String>();
        Set<String> setDealerAppColDef = new Set<String>();
        Map<String, String> mapIdUsrNomDis = new Map<String, String>();
        Map<String, String> mapNomGrupoIdGrupo = new Map<String, String>();
        Map<String, String> mapNoDealerNomGrupo = new Map<String, String>();
        List<TAM_InventarioVehiculosToyota__Share >  lInvenVehiculoShare = new List<TAM_InventarioVehiculosToyota__Share >();
        Map<String, List<TAM_AdminInventarioDealer__c>> MapNoCaveDeaObjAdmInvDea = new Map<String, List<TAM_AdminInventarioDealer__c>>(); 
        Map<String, List<TAM_InventarioVehiculosToyota__c>> MapNoCaveDeaObjInvToy = new Map<String, List<TAM_InventarioVehiculosToyota__c>>(); 
        
        String sFleterosColaboracionEspecial = System.Label.TAM_FleterosColaboracionEspecial;
        String sCuernavacaColaboracionEspecial = System.Label.TAM_CuernavacaColaboracionEspecial;
        Boolean blnAplicaColaboraDefault = false;
        
        for(TAM_InventarioVehiculosToyota__c objInvenFyG : lstNewClienteVehiculo){
            //Ve si tiene algo el cammpo de Dealer_Code__c
            if (objInvenFyG.Dealer_Code__c != null)
                setVodDealer.add(objInvenFyG.Dealer_Code__c);
            if (MapNoCaveDeaObjInvToy.containsKey(objInvenFyG.Dealer_Code__c))
                MapNoCaveDeaObjInvToy.get(objInvenFyG.Dealer_Code__c).add(objInvenFyG);
            if (!MapNoCaveDeaObjInvToy.containsKey(objInvenFyG.Dealer_Code__c))
                MapNoCaveDeaObjInvToy.put(objInvenFyG.Dealer_Code__c, new List<TAM_InventarioVehiculosToyota__c>{objInvenFyG});                
        }//Fin del for para lstNewClienteVehiculo
        System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler setVodDealer: ' + setVodDealer);           
        System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler MapNoCaveDeaObjInvToy: ' + MapNoCaveDeaObjInvToy.KeySet());           
        System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler MapNoCaveDeaObjInvToy: ' + MapNoCaveDeaObjInvToy.Values());           

        //Busca el Dealer_Code__c y ve si ya tiene una colaboración creada especial
        for (TAM_AdminInventarioDealer__c objAdmInvDea : [Select t.TAM_DistribuidorAsociado__c, t.TAM_CodigoDistribuidor__c, 
               t.TAM_AplicaColarobarionDefault__c, TAM_Funcion__c, TAM_TipoInventario__c 
               From TAM_AdminInventarioDealer__c t Where TAM_CodigoDistribuidor__c =:setVodDealer ]){
            //Metelo al mapa de MapNoCaveDeaObjAdmInvDea
            if (MapNoCaveDeaObjAdmInvDea.containsKey(objAdmInvDea.TAM_CodigoDistribuidor__c))
                MapNoCaveDeaObjAdmInvDea.get(objAdmInvDea.TAM_CodigoDistribuidor__c).add(objAdmInvDea); 
            if (!MapNoCaveDeaObjAdmInvDea.containsKey(objAdmInvDea.TAM_CodigoDistribuidor__c))
                MapNoCaveDeaObjAdmInvDea.put(objAdmInvDea.TAM_CodigoDistribuidor__c, new List<TAM_AdminInventarioDealer__c>{objAdmInvDea});
        }//Fin del for para 
        System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler MapNoCaveDeaObjAdmInvDea: ' + MapNoCaveDeaObjAdmInvDea.KeySet());           
        System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler MapNoCaveDeaObjAdmInvDea: ' + MapNoCaveDeaObjAdmInvDea.Values());           

        //Consulta los grupos 
        for (Account Dealer : [SELECT ID, Codigo_Distribuidor__c, Name 
            FROM Account WHERE Codigo_Distribuidor__c IN :setVodDealer ORDER BY NAME]){
            String sName = Dealer.Name;    
            mapNoDealerNomGrupo.put(Dealer.Codigo_Distribuidor__c, sName.toUpperCase());
        }
        System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler mapNoDealerNomGrupo: ' + mapNoDealerNomGrupo.KeySet());           
        System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler mapNoDealerNomGrupo: ' + mapNoDealerNomGrupo.Values());           
                
        //Consulta los grupos 
        for (Group Gropo : [SELECT ID, Name FROM Group WHERE (NAME LIKE '%TOYOTA%' OR NAME LIKE '%TMEX%') ORDER BY NAME]){
            String sNombreGrupo = Gropo.Name;
            mapNomGrupoIdGrupo.put(sNombreGrupo, Gropo.id);
            sNombreGrupo = Gropo.Name + ' ASESOR';
            mapNomGrupoIdGrupo.put(sNombreGrupo, Gropo.id);
        }
        System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler mapNomGrupoIdGrupo: ' + mapNomGrupoIdGrupo.KeySet());           
        System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler mapNomGrupoIdGrupo: ' + mapNomGrupoIdGrupo.Values());           

        //Si es una prueba
        if (Test.isRunningTest()) blnPermiteColaborarInventario = true;
        System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler blnPermiteColaborarInventario: ' + blnPermiteColaborarInventario);           

        if (blnPermiteColaborarInventario){
        //Recorre el mapa de MapNoCaveDeaObjInvToy
        for (String sCodDealerPaso : MapNoCaveDeaObjInvToy.keySet()){
            Boolean blnAplicaColDefault = false;
            
            //Busca si existe el sCodDealerPaso en MapNoCaveDeaObjAdmInvDea
            if (MapNoCaveDeaObjAdmInvDea.containsKey(sCodDealerPaso)){
                //Recorre la lista de los objeto de TAM_AdminInventarioDealer__c
                List<TAM_AdminInventarioDealer__c> lAdmininvDeal = MapNoCaveDeaObjAdmInvDea.get(sCodDealerPaso);
                System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler TIENE REG EN MapNoCaveDeaObjAdmInvDea lAdmininvDeal: ' + lAdmininvDeal);
                //Recorre la lista de lAdmininvDeal
                for (TAM_AdminInventarioDealer__c objAdmInvDea : lAdmininvDeal){
                    //Si es una prueba
                    if (Test.isRunningTest()) objAdmInvDea.TAM_AplicaColarobarionDefault__c = true;
                    //Ve si tiene colaboración con otros dealers
                    if (objAdmInvDea.TAM_AplicaColarobarionDefault__c){
                        blnAplicaColDefault = true;
                        //Ve si tiene dist rel
                        if (objAdmInvDea.TAM_DistribuidorAsociado__c != null){
	                        //Toma la lista de Inv de MapNoCaveDeaObjInvToy
	                        List<TAM_InventarioVehiculosToyota__c> lInvVeicToyPaso = MapNoCaveDeaObjInvToy.get(sCodDealerPaso);
                            System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler TIENE REG EN lInvVeicToyPaso: ' + lInvVeicToyPaso);
                            //Si es una prueba
                            if (Test.isRunningTest()) objAdmInvDea.TAM_DistribuidorAsociado__c = 'Toyota Bajío Sur;';
	                        //Despedaza la cadena de TAM_DistribuidorAsociado__c por el caracter de ;
	                        String[] lDealerColabora = objAdmInvDea.TAM_DistribuidorAsociado__c.contains(';') ? objAdmInvDea.TAM_DistribuidorAsociado__c.split(';') : new List<String>{objAdmInvDea.TAM_DistribuidorAsociado__c};
                            //Agregar el del ditribuoidor origen sCodDealerPaso
                            if (!Test.isRunningTest())
                                lDealerColabora.add(mapNoDealerNomGrupo.get(sCodDealerPaso));
                            System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler TIENE REG EN lDealerColabora: ' + lDealerColabora);
	                        //Recorre la lista de lDealerColabora
	                        for (String sDealer : lDealerColabora){
	                            //Recorre la lista de lInvVeicToyPaso
	                            for (TAM_InventarioVehiculosToyota__c objInvVehToy : lInvVeicToyPaso){
	                                System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler objInvVehToy1: ' + objInvVehToy);
	                                String sDealerPaso = sDealer.toUpperCase();
	                                //crea el objeto del tipo TAM_InventarioVehiculosToyota__Share
	                                TAM_InventarioVehiculosToyota__Share objPasoShare = new TAM_InventarioVehiculosToyota__Share (
	                                     ParentId = objInvVehToy.id, UserOrGroupId = mapNomGrupoIdGrupo.get(sDealerPaso), AccessLevel = 'Edit');
	                                System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler sDealerPaso1 : ' + sDealerPaso + ' objPasoShare: ' + objPasoShare);
	                                //Agregalo a la lista de lInvenVehiculoShare
                                    if (blnPermiteColaborarInventario)
	                                   lInvenVehiculoShare.add(objPasoShare);                                 
	        
	                                sDealerPaso = sDealer.toUpperCase() + ' ASESOR';
	                                //crea el objeto del tipo TAM_InventarioVehiculosToyota__Share
	                                TAM_InventarioVehiculosToyota__Share objPasoShareAsor = new TAM_InventarioVehiculosToyota__Share (
	                                    ParentId = objInvVehToy.id, UserOrGroupId = mapNomGrupoIdGrupo.get(sDealerPaso), AccessLevel = 'Edit');                     
	                                System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler sDealerPaso2 : ' + sDealerPaso + ' objPasoShareAsor: ' + objPasoShareAsor);
	                                //Agregalo a la lista de lInvenVehiculoShare
                                    if (blnPermiteColaborarInventario)
	                                   lInvenVehiculoShare.add(objPasoShareAsor);
	                            }//Fin si 
	                        }//Fin del for para lDealerColabora                        
                        }//Fin si objAdmInvDea.TAM_DistribuidorAsociado__c != null

                        //Si es una prueba
                        if (Test.isRunningTest()) objAdmInvDea.TAM_DistribuidorAsociado__c = null;                        
                        //Ve si no tiene dist rel
                        if (objAdmInvDea.TAM_DistribuidorAsociado__c == null){
                            System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler TIENE REG EN MapNoCaveDeaObjAdmInvDea NO TIENE DIST ASOCIADO sCodDealerPaso: ' + sCodDealerPaso);
                            //Toma la lista de Inv de MapNoCaveDeaObjInvToy
                            List<TAM_InventarioVehiculosToyota__c> lInvVeicToyPaso = MapNoCaveDeaObjInvToy.get(sCodDealerPaso);
					        //Crea la colaboracion para el reg 
					        for(TAM_InventarioVehiculosToyota__c objInvenFyG : lInvVeicToyPaso){
					            
					            String sNombreGrupo = mapNoDealerNomGrupo.containsKey(sCodDealerPaso) ? mapNoDealerNomGrupo.get(sCodDealerPaso) : ' ';
					            System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler sNombreGrupo: ' + sNombreGrupo);
					            if (Test.isRunningTest())
					                sNombreGrupo = 'TOYOTA INNOVA FLETEROS';
					            //crea el objeto del tipo TAM_InventarioVehiculosToyota__Share
					            TAM_InventarioVehiculosToyota__Share  objPasoShare = new TAM_InventarioVehiculosToyota__Share (
					                    ParentId = objInvenFyG.id,
					                    UserOrGroupId = mapNomGrupoIdGrupo.get(sNombreGrupo),
					                    AccessLevel = 'Edit'
					            );
					            //Agregalo a la lista lInvenVehiculoShare
                                if (blnPermiteColaborarInventario)
				                    lInvenVehiculoShare.add(objPasoShare);
					            System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler objPasoShare: ' + objPasoShare); 
				                String sNombreGrupo2 = mapNoDealerNomGrupo.containsKey(sCodDealerPaso) ? mapNoDealerNomGrupo.get(sCodDealerPaso) + ' ASESOR': ' ';           
					            System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler sNombreGrupo2: ' + sNombreGrupo2);
					            //crea el objeto del tipo TAM_InventarioVehiculosToyota__Share
					            TAM_InventarioVehiculosToyota__Share  objPasoShareAsesor = new TAM_InventarioVehiculosToyota__Share (
					                ParentId = objInvenFyG.id,
					                UserOrGroupId = mapNomGrupoIdGrupo.get(sNombreGrupo2),
					                AccessLevel = 'Edit'
					            );
					            System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler objPasoShareAsesor: ' + objPasoShareAsesor); 
					            //Agregalo a la lista lInvenVehiculoShare   
                                if (blnPermiteColaborarInventario)
				                   lInvenVehiculoShare.add(objPasoShareAsesor);
								                         
					        }//Fin del for para lInvVeicToyPaso
                        
                        }//Fin si objAdmInvDea.TAM_DistribuidorAsociado__c == null                        
                    }//Fin si objAdmInvDea.TAM_AplicaColarobarionDefault__c                
                
                }//Fin del for para lAdmininvDeal

                //Si es una prueba
                if (Test.isRunningTest()) blnAplicaColDefault = false;
                
                //Ve si !blnAplicaColDefault
                if (!blnAplicaColDefault){
                    System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler TIENE REG EN MapNoCaveDeaObjAdmInvDea NO APLICA COLABORAPOR DEFAULT sCodDealerPaso: ' + sCodDealerPaso);

                    Boolean blnTieneDistRel = false;
                    String strDistRel = '';
                    Boolean blnTieneRegDistRel = false;
                    List<TAM_AdminInventarioDealer__c> lReglasDistRel = new List<TAM_AdminInventarioDealer__c>();
                    
	                //Recorre la lista de lAdmininvDeal y ve si tiene dist relacionados y ademas reglas
	                for (TAM_AdminInventarioDealer__c objAdmInvDea : lAdmininvDeal){
	                     if (objAdmInvDea.TAM_DistribuidorAsociado__c != null) {
	                         strDistRel = objAdmInvDea.TAM_DistribuidorAsociado__c;
	                         blnTieneDistRel = true;
	                     }//Fin si objAdmInvDea.TAM_DistribuidorAsociado__c == null
	                     //Ve si tiene reglas
                         if (objAdmInvDea.TAM_Funcion__c != null && objAdmInvDea.TAM_TipoInventario__c != null) {
                             blnTieneRegDistRel = true;
                             lReglasDistRel.add(objAdmInvDea);
                         }//Fin si objAdmInvDea.TAM_Funcion__c != null && objAdmInvDea.TAM_TipoInventario__c != null
	                }//Fin del for para lAdmininvDeal
	                
			        //Si es una prueba
			        if(Test.isRunningTest()){ 
			            blnTieneDistRel = true;
			            blnTieneRegDistRel = false;
			            strDistRel = 'Toyota Bajío Sur;';
			        }//Test.isRunningTest()
	                
	                //Ahora si aplica la colaboración,ve si tiene dist rel pero no dio de alta reglas
	                if (blnTieneDistRel && !blnTieneRegDistRel){
                        System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler ENTRO A TIENE DIST REL Y NO REGLAS...');	                     
                        //Toma la lista de Inv de MapNoCaveDeaObjInvToy
                        List<TAM_InventarioVehiculosToyota__c> lInvVeicToyPaso = MapNoCaveDeaObjInvToy.get(sCodDealerPaso);
                        System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler ENTRO A TIENE DIST REL Y NO REGLAS lInvVeicToyPaso: ' + lInvVeicToyPaso);                         
                        //Despedaza la cadena de TAM_DistribuidorAsociado__c por el caracter de ;
                        String[] lDealerColabora = strDistRel.contains(';') ? strDistRel.split(';') : new List<String>{strDistRel};
                        for (String sDealer : lDealerColabora){
                            System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler ENTRO A TIENE DIST REL Y NO REGLAS sDealer: ' + sDealer);
                            //Recorre la lista de lInvVeicToyPaso
                            for (TAM_InventarioVehiculosToyota__c objInvVehToy : lInvVeicToyPaso){
                                System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler objInvVehToy1: ' + objInvVehToy);
                                String sDealerPaso = sDealer.toUpperCase();
                                //crea el objeto del tipo TAM_InventarioVehiculosToyota__Share
                                TAM_InventarioVehiculosToyota__Share objPasoShare = new TAM_InventarioVehiculosToyota__Share (
                                     ParentId = objInvVehToy.id, UserOrGroupId = mapNomGrupoIdGrupo.get(sDealerPaso), AccessLevel = 'Edit');
                                System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler sDealerPaso1 : ' + sDealerPaso + ' objPasoShare: ' + objPasoShare);
                                //Agregalo a la lista de lInvenVehiculoShare
                                if (blnPermiteColaborarInventario)
                                    lInvenVehiculoShare.add(objPasoShare);                                 
            
                                sDealerPaso = sDealer.toUpperCase() + ' ASESOR';
                                //crea el objeto del tipo TAM_InventarioVehiculosToyota__Share
                                TAM_InventarioVehiculosToyota__Share objPasoShareAsor = new TAM_InventarioVehiculosToyota__Share (
                                    ParentId = objInvVehToy.id, UserOrGroupId = mapNomGrupoIdGrupo.get(sDealerPaso), AccessLevel = 'Edit');                     
                                System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler sDealerPaso2 : ' + sDealerPaso + ' objPasoShareAsor: ' + objPasoShareAsor);
                                //Agregalo a la lista de lInvenVehiculoShare
                                if (blnPermiteColaborarInventario)
                                    lInvenVehiculoShare.add(objPasoShareAsor);
                            }//Fin si 
                        }//Fin del for para lDealerColabora                        
	                }//Fin si blnTieneDistRel && !blnTieneDistRel

			        //Si es una prueba
			        if(Test.isRunningTest()){ 
			            blnTieneDistRel = false;
			            blnTieneRegDistRel = true;
			        }//Test.isRunningTest()
	                
                    //Ahora si aplica la colaboración,ve si NO tiene dist rel pero SI dio de alta reglas
                    if (!blnTieneDistRel && blnTieneRegDistRel){
                        System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler ENTRO Y NO TIENE DIST PER SI REGLAS...');                         
				        //Ya tienes los Id de los inventarios que va a colaborar busca las funciones e inventarios que aplica
				        for (TAM_AdminInventarioDealer__c objAdminInveDealer : lReglasDistRel){
				            String sNameDist = mapNoDealerNomGrupo.get(sCodDealerPaso);
				            //Toma las funciones primero TAM_Funcion__c, TAM_TipoInventario__c
				            String sFuncionPsso = objAdminInveDealer.TAM_Funcion__c;
				            String[] arrFunciones = sFuncionPsso != null ? sFuncionPsso.split(';') : new List<String>();
				            Set<String> setFunciones = new Set<String>();
				            Set<String> setUsersFunciones = new Set<String>();
				
				            //Dale vuelta a la lista de arrFunciones
				            for (String sFuncPaso : arrFunciones){
				                //Crea el nombre de la funcion 
				                String sNameFuncion;
				                String sFuncPasoPaso = sFuncPaso.toUpperCase();
				                System.debug('ENTRO TAM_CreaColaboraCustomInventBch_cls sFuncPasoPaso: ' + sFuncPasoPaso);           
				                if (sFuncPasoPaso == 'EJECUTIVO') 
				                    sNameFuncion = sNameDist + ' Socio Ejecutivo';
				                if (sFuncPasoPaso == 'GESTOR') 
				                    sNameFuncion = sNameDist + ' Socio Gestor';
				                if (sFuncPasoPaso == 'ASESOR') 
				                    sNameFuncion = sNameDist + ' Socio Usuario';
				                //Agregalo al set de setFunciones                    
				                setFunciones.add(sNameFuncion);
				            }//Fin del for para arrFunciones
				            //Consulta los usuaros asociados a las funciones setFunciones 
				            for (User usuario : [Select u.id, u.Name, u.CodigoDistribuidor__c, u.UserRole.Name 
				                From User u Where u.IsActive = true and UserRole.Name IN :setFunciones]){
				                //Metelos en el SET de setUsersFunciones
				                setUsersFunciones.add(usuario.id);
				            }
				            System.debug('ENTRO TAM_DepuraColaboraInventBch_cls setUsersFunciones: ' + setUsersFunciones);
				
				            Set<String> setInventarios = new Set<String>();                       
				            //Ya tienes a los usuarios ve por el tipo de inventario que le aplica
				            String[] arrInventario = objAdminInveDealer.TAM_TipoInventario__c != null ? objAdminInveDealer.TAM_TipoInventario__c.split(';') : new List<String>();
				            //Dale vuelta a la lista de arrFunciones
				            for (String sInventPaso : arrInventario){
				                //Crea el nombre de la funcion 
				                String sNameInvenPaso = '';
				                String sInventPasoPaso = sInventPaso.toUpperCase();
				                System.debug('ENTRO TAM_CreaColaboraCustomInventBch_cls sInventPasoPaso: ' + sInventPasoPaso);           
				                if (sInventPasoPaso == 'PRODUCCIÓN') 
				                    sNameInvenPaso = 'A';
				                if (sInventPasoPaso == 'TRÁFICO') 
				                    sNameInvenPaso = 'F';
				                if (sInventPasoPaso == 'PISO') 
				                    sNameInvenPaso = 'F';
				                //Agregalo al set de setFunciones                    
				                setInventarios.add(sNameInvenPaso);
				            }//Fin del for para arrFunciones
				            System.debug('ENTRO TAM_DepuraColaboraInventBch_cls setInventarios: ' + setInventarios);
				            
                            //Toma la lista de Inv de MapNoCaveDeaObjInvToy
                            List<TAM_InventarioVehiculosToyota__c> lInvVeicToyPaso = MapNoCaveDeaObjInvToy.get(sCodDealerPaso);
                            Set<String> setIdInvToyPaso = setIdInvToy(lInvVeicToyPaso);
                            System.debug('ENTRO TAM_DepuraColaboraInventBch_cls setIdInvToyPaso0: ' + setIdInvToyPaso);
				            //Consulta los inventarios que vienen en 
				            for (TAM_InventarioVehiculosToyota__c objInvPaso : [Select id From TAM_InventarioVehiculosToyota__c
				                Where TAM_TipoInventarioLetra__c IN: setInventarios And Id IN :setIdInvToyPaso]){
				                //Recorre la lista de usuarios activos para las funciones
				                for (String sUsrPaso : setUsersFunciones){
				                    //crea el objeto del tipo TAM_InventarioVehiculosToyota__Share
				                    TAM_InventarioVehiculosToyota__Share  objPasoShare = new TAM_InventarioVehiculosToyota__Share (
				                            ParentId = objInvPaso.id,
				                            UserOrGroupId = sUsrPaso,
				                            AccessLevel = 'Edit'
				                    );
			                       //Metelo a la lista de lInvenVehiculoShare 
                                    if (blnPermiteColaborarInventario)
			                             lInvenVehiculoShare.add(objPasoShare);
				                }//Fin del for para setUsersFunciones
				            }//Fin del for para TAM_InventarioVehiculosToyota__c
				        }//Fin del for para this.lAdminInventarioDealerPrm                                       
                    }//Fin si !blnTieneDistRel && blnTieneDistRel

			        //Si es una prueba
			        if(Test.isRunningTest()){ 
			            blnTieneDistRel = true;
			            blnTieneRegDistRel = true;
			        }//Test.isRunningTest()

                    //Ahora si aplica la colaboración, ve SI tiene dist rel y SI tiene reglas
                    if (blnTieneDistRel && blnTieneRegDistRel){
                        System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler ENTRO TIENE DIST Y REGLAS strDistRel: ' + strDistRel);
                        String sNameDist = mapNoDealerNomGrupo.get(sCodDealerPaso);
                        System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler ENTRO TIENE DIST Y REGLAS sNameDist: ' + sNameDist);

                        //Concatena al la lista de strDistRel el sNameDist 
                        if (strDistRel == null)
                            strDistRel = '';
                        strDistRel += ';' + sNameDist + ';';
                        //Despedaza la cadena de TAM_DistribuidorAsociado__c por el caracter de ;
                        String[] lDealerColabora = strDistRel.contains(';') ? strDistRel.split(';') : new List<String>();
                        System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler ENTRO TIENE DIST Y REGLAS strDistRel: ' + strDistRel + ' lDealerColabora: ' + lDealerColabora);                                                 
                        
                        //La variables para los invent, las funciones y los usuarios finales
                        Set<String> setInventarios = new Set<String>();                       
                        Set<String> setFunciones = new Set<String>();
                        Set<String> setUsersFunciones = new Set<String>();                        
                        //Ya tienes los Id de los inventarios que va a colaborar busca las funciones e inventarios que aplica
                        for (TAM_AdminInventarioDealer__c objAdminInveDealer : lReglasDistRel){
                            //Recorre la lista de lDealerColabora
                            for (String sNameDistPaso : lDealerColabora){
                                //Toma las funciones primero TAM_Funcion__c, TAM_TipoInventario__c
                                String sFuncionPsso = objAdminInveDealer.TAM_Funcion__c;
                                String[] arrFunciones = sFuncionPsso != null ? sFuncionPsso.split(';') : new List<String>();
                                //Dale vuelta a la lista de arrFunciones
                                for (String sFuncPaso : arrFunciones){
                                    //Crea el nombre de la funcion 
                                    String sNameFuncion;
                                    String sFuncPasoPaso = sFuncPaso.toUpperCase();
                                    System.debug('ENTRO TAM_CreaColaboraCustomInventBch_cls sFuncPasoPaso: ' + sFuncPasoPaso);           
                                    if (sFuncPasoPaso == 'EJECUTIVO') 
                                        sNameFuncion = sNameDistPaso + ' Socio Ejecutivo';
                                    if (sFuncPasoPaso == 'GESTOR') 
                                        sNameFuncion = sNameDistPaso + ' Socio Gestor';
                                    if (sFuncPasoPaso == 'ASESOR') 
                                        sNameFuncion = sNameDistPaso + ' Socio Usuario';
                                    System.debug('ENTRO TAM_CreaColaboraCustomInventBch_cls sNameFuncion: ' + sNameFuncion);           
                                    //Agregalo al set de setFunciones                    
                                    setFunciones.add(sNameFuncion);
                                }//Fin del for para arrFunciones
                                //Consulta los usuaros asociados a las funciones setFunciones 
                                for (User usuario : [Select u.id, u.Name, u.CodigoDistribuidor__c, u.UserRole.Name 
                                    From User u Where u.IsActive = true and UserRole.Name IN :setFunciones]){
                                    //Metelos en el SET de setUsersFunciones
                                    setUsersFunciones.add(usuario.id);
                                }//Fin del for para User
                                //Ya tienes a los usuarios ve por el tipo de inventario que le aplica
                                String[] arrInventario = objAdminInveDealer.TAM_TipoInventario__c != null ? objAdminInveDealer.TAM_TipoInventario__c.split(';') : new List<String>();
                                //Dale vuelta a la lista de arrFunciones
                                for (String sInventPaso : arrInventario){
                                    //Crea el nombre de la funcion 
                                    String sNameInvenPaso = '';
                                    String sInventPasoPaso = sInventPaso.toUpperCase();
                                    System.debug('ENTRO TAM_CreaColaboraCustomInventBch_cls sInventPasoPaso: ' + sInventPasoPaso);           
                                    if (sInventPasoPaso == 'PRODUCCIÓN') 
                                        sNameInvenPaso = 'A';
                                    if (sInventPasoPaso == 'TRÁFICO') 
                                        sNameInvenPaso = 'F';
                                    if (sInventPasoPaso == 'PISO') 
                                        sNameInvenPaso = 'F';
                                    System.debug('ENTRO TAM_CreaColaboraCustomInventBch_cls sNameInvenPaso: ' + sNameInvenPaso);
                                    //Agregalo al set de setFunciones                    
                                    setInventarios.add(sNameInvenPaso);
                                }//Fin del for para arrFunciones
                            }//Fin del for para 
                            //System.debug('ENTRO TAM_DepuraColaboraInventBch_cls setFunciones2: ' + setFunciones);                         
                            //System.debug('ENTRO TAM_DepuraColaboraInventBch_cls setInventarios2: ' + setInventarios);                         
                            //System.debug('ENTRO TAM_DepuraColaboraInventBch_cls setUsersFunciones2: ' + setUsersFunciones);                            
                            //Toma la lista de Inv de MapNoCaveDeaObjInvToy
                            List<TAM_InventarioVehiculosToyota__c> lInvVeicToyPaso = MapNoCaveDeaObjInvToy.get(sCodDealerPaso);
                            Set<String> setIdInvToyPaso = setIdInvToy(lInvVeicToyPaso);
                            System.debug('ENTRO TAM_DepuraColaboraInventBch_cls setIdInvToyPaso: ' + setIdInvToyPaso);
                            //Consulta los inventarios que vienen en 
                            for (TAM_InventarioVehiculosToyota__c objInvPaso : [Select id From TAM_InventarioVehiculosToyota__c
                                Where TAM_TipoInventarioLetra__c IN: setInventarios And Id IN :setIdInvToyPaso]){
                                System.debug('ENTRO TAM_DepuraColaboraInventBch_cls entro a la consulta de InventPaso2: ' + objInvPaso);                         
                                //Recorre la lista de usuarios activos para las funciones
                                for (String sUsrPaso : setUsersFunciones){
                                    //crea el objeto del tipo TAM_InventarioVehiculosToyota__Share
                                    TAM_InventarioVehiculosToyota__Share  objPasoShare = new TAM_InventarioVehiculosToyota__Share (
                                            ParentId = objInvPaso.id,
                                            UserOrGroupId = sUsrPaso,
                                            AccessLevel = 'Edit'
                                    );
                                    System.debug('ENTRO TAM_DepuraColaboraInventBch_cls entro a la consulta de objPasoShare2: ' + objPasoShare);                         
                                   //Metelo a la lista de lInvenVehiculoShare 
                                    if (blnPermiteColaborarInventario)
                                        lInvenVehiculoShare.add(objPasoShare);
                                }//Fin del for para setUsersFunciones
                            }//Fin del for para TAM_InventarioVehiculosToyota__c
                            //System.debug('ENTRO TAM_DepuraColaboraInventBch_cls lInvenVehiculoShare1: ' + lInvenVehiculoShare);                                                     
                        }//Fin del for para this.lAdminInventarioDealerPrm
                        System.debug('ENTRO TAM_DepuraColaboraInventBch_cls lInvenVehiculoShare2: ' + lInvenVehiculoShare);                                                                 
                    }//Fin si blnTieneDistRel && blnTieneDistRel
	                
                }//Fin si !blnAplicaColDefault
                
            }//Fin si MapNoCaveDeaObjAdmInvDea.containsKey(sCodDealerPaso)

            //Busca si existe el sCodDealerPaso en MapNoCaveDeaObjAdmInvDea
            if (!MapNoCaveDeaObjAdmInvDea.containsKey(sCodDealerPaso)){
               System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler NO TIENE REG EN MapNoCaveDeaObjAdmInvDea sCodDealerPaso: ' + sCodDealerPaso);
               blnAplicaColaboraDefault = true;
               setDealerAppColDef.add(sCodDealerPaso);
            }//Le toca colaboración por default        
            
        }//Fin for para sCodDealerPaso
        } //Fin si blnPermiteColaborarInventario
        System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler blnAplicaColaboraDefault: ' + blnAplicaColaboraDefault);
        System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler setDealerAppColDef: ' + setDealerAppColDef);
                
        //Crea la colaboracion para el reg si no puede crear colaboración de acuerdo a esta variable  blnPermiteColaborarInventario 
        for(TAM_InventarioVehiculosToyota__c objInvenFyG : lstNewClienteVehiculo){
            String sNombreGrupo = mapNoDealerNomGrupo.containsKey(objInvenFyG.Dealer_Code__c) ? mapNoDealerNomGrupo.get(objInvenFyG.Dealer_Code__c) : ' ';
            System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler sNombreGrupo: ' + sNombreGrupo);
            if (Test.isRunningTest())
                sNombreGrupo = 'TOYOTA INNOVA FLETEROS';
            //crea el objeto del tipo TAM_InventarioVehiculosToyota__Share
            TAM_InventarioVehiculosToyota__Share  objPasoShare = new TAM_InventarioVehiculosToyota__Share (
                    ParentId = objInvenFyG.id,
                    UserOrGroupId = mapNomGrupoIdGrupo.get(sNombreGrupo),
                    AccessLevel = 'Edit'
            );
            //Agregalo a la lista lInvenVehiculoShare
            if (!blnPermiteColaborarInventario || setDealerAppColDef.contains(objInvenFyG.Dealer_Code__c)){
                lInvenVehiculoShare.add(objPasoShare);
                System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler objPasoShare: ' + objPasoShare); 
            }//Fin si !blnPermiteColaborarInventario || blnAplicaColaboraDefault
            
            //Ve si se trata de Inova Fleteros y el inventario del tipo G
            if ( (objInvenFyG.Dealer_Code__c == sFleterosColaboracionEspecial || objInvenFyG.Dealer_Code__c == sCuernavacaColaboracionEspecial) 
                && objInvenFyG.TAM_TipoInventarioLetra__c == 'G'){
               String sNombreGrupo2 = mapNoDealerNomGrupo.containsKey(objInvenFyG.Dealer_Code__c) ? mapNoDealerNomGrupo.get(objInvenFyG.Dealer_Code__c) + ' ASESOR': ' ';           
               System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler sNombreGrupo1: ' + sNombreGrupo2);
                //crea el objeto del tipo TAM_InventarioVehiculosToyota__Share
                TAM_InventarioVehiculosToyota__Share  objPasoShareAsesor = new TAM_InventarioVehiculosToyota__Share (
                    ParentId = objInvenFyG.id,
                    UserOrGroupId = mapNomGrupoIdGrupo.get(sNombreGrupo2),
                    AccessLevel = 'Edit'
                );
                System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler objPasoShareAsesor1.0: ' + objPasoShareAsesor); 
                //Agregalo a la lista lInvenVehiculoShare   
                if (!blnPermiteColaborarInventario || setDealerAppColDef.contains(objInvenFyG.Dealer_Code__c)){   
                    lInvenVehiculoShare.add(objPasoShareAsesor);
                    System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler sNombreGrupo1.1: ' + sNombreGrupo2);
                }//Fin si !blnPermiteColaborarInventario
            }//Fin si objInvenFyG.TAM_TipoInventarioLetra__c == 'G'

            //Ve si se trata de un dos diferente de Inova Fleteros
            if ( objInvenFyG.Dealer_Code__c != sFleterosColaboracionEspecial && objInvenFyG.Dealer_Code__c != sCuernavacaColaboracionEspecial ){
               String sNombreGrupo2 = mapNoDealerNomGrupo.containsKey(objInvenFyG.Dealer_Code__c) ? mapNoDealerNomGrupo.get(objInvenFyG.Dealer_Code__c) + ' ASESOR': ' ';           
               System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler sNombreGrupo2: ' + sNombreGrupo2);
                //crea el objeto del tipo TAM_InventarioVehiculosToyota__Share
                TAM_InventarioVehiculosToyota__Share  objPasoShareAsesor = new TAM_InventarioVehiculosToyota__Share (
                    ParentId = objInvenFyG.id,
                    UserOrGroupId = mapNomGrupoIdGrupo.get(sNombreGrupo2),
                    AccessLevel = 'Edit'
                );
                System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler objPasoShareAsesor2.0: ' + objPasoShareAsesor); 
                //Agregalo a la lista lInvenVehiculoShare   
                if (!blnPermiteColaborarInventario || setDealerAppColDef.contains(objInvenFyG.Dealer_Code__c)){
                    lInvenVehiculoShare.add(objPasoShareAsesor);
                   System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler sNombreGrupo2.1: ' + sNombreGrupo2);
                }//Fin si !blnPermiteColaborarInventario || blnAplicaColaboraDefault
            }//Fin si objInvenFyG.TAM_TipoInventarioLetra__c == 'G'

        }//Fin del for para lstNewClienteVehiculo
        
        
        System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler lInvenVehiculoShare FINAL: ' + lInvenVehiculoShare);
        //Un punto de retorno
        SavePoint svInv = Database.setSavepoint();

        if (!lInvenVehiculoShare.isEmpty()){
            //Actualiza las Opp 
            List<Database.Saveresult> lDtbUpsRes = Database.insert(lInvenVehiculoShare, false);
            //Ve si hubo error
            for (Database.Saveresult objDtbUpsRes : lDtbUpsRes){
                if (!objDtbUpsRes.isSuccess())
                    System.debug('En la AccSh: hubo error a la hora de crear/Actualizar el TAM_InventarioVehiculosToyota__Share de la Opp: ' + objDtbUpsRes.getErrors()[0].getMessage());
            }//Fin del for para lDtbUpsRes
        }//Fin si !lInvenVehiculoShare.isEmpty()
        
        //Rollback para pruebas            
        //Database.rollback(svInv);                    
                    
    }
    
    //Llama el metodo de actualizaDod para actuelizar el tipo de invcentario en el objeto de 
    public static Set<String> setIdInvToy(List<TAM_InventarioVehiculosToyota__c> lstNewClienteVehiculo){
        System.debug('EN setIdInvToy...');
        Set<String> setIdInvToyPaso = new Set<String>();
        
        //Recorre la lista de TAM_InventarioVehiculosToyota__c
        for (TAM_InventarioVehiculosToyota__c objInvPaso : lstNewClienteVehiculo){
            setIdInvToyPaso.add(objInvPaso.id);
        }//Fin del for para lstNewClienteVehiculo
        
        System.debug('EN setIdInvToy setIdInvToyPaso: ' + setIdInvToyPaso);        
        return setIdInvToyPaso;
    }    
    
    //Llama el metodo de actualizaDod para actuelizar el tipo de invcentario en el objeto de 
    public static void actualizaDod(List<TAM_InventarioVehiculosToyota__c> lstNewClienteVehiculo){
        Set<String> setIdExtMod = new Set<String>();
        Set<String> setIdExtAnio = new Set<String>();
        Map<String, TAM_InventarioVehiculosToyota__c> mapIdExtCodMod = new Map<String, TAM_InventarioVehiculosToyota__c>();
        Map<String, TAM_DODSolicitudesPedidoEspecial__c> mapIdDodObj = new Map<String, TAM_DODSolicitudesPedidoEspecial__c>();
        
        System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler actualizaDod...');           
        for(TAM_InventarioVehiculosToyota__c objInvenFyG : lstNewClienteVehiculo){
            //Ve si tiene algo el cammpo de Dealer_Code__c
            if (objInvenFyG.Model_Number__c != null && objInvenFyG.TAM_Dummy_VIN_Temp__c != null)
                mapIdExtCodMod.put(objInvenFyG.TAM_Dummy_VIN_Temp__c, objInvenFyG);                
            if (objInvenFyG.Model_Number__c != null && objInvenFyG.Dummy_VIN__c != null)
                mapIdExtCodMod.put(objInvenFyG.Dummy_VIN__c, objInvenFyG);
        }
        System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler actualizaDod mapIdExtCodMod: ' + mapIdExtCodMod);
        System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler actualizaDod mapIdExtCodMod: ' + mapIdExtCodMod);
        
        //Consulta los datos del objeto de DOD en el campo de 
        for (TAM_DODSolicitudesPedidoEspecial__c objDodo : [Select ID, TAM_DummyVin__c, TAM_DummyVINFormula__c, TAM_Codigo__c, TAM_VIN__c, TAM_Estatus__c
            From TAM_DODSolicitudesPedidoEspecial__c t
            Where TAM_DummyVINFormula__c IN: mapIdExtCodMod.KeySet()]){
            System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler actualizaDod objDodo: ' + objDodo);
                
            //Busca el TAM_DummyVin__c en el mapa de mapIdExtCodMod
            if (mapIdExtCodMod.containsKey(objDodo.TAM_DummyVINFormula__c)){
                String sTipoInv = mapIdExtCodMod.get(objDodo.TAM_DummyVINFormula__c).TAM_TipoInventarioLetra__c + ' - ' + mapIdExtCodMod.get(objDodo.TAM_DummyVINFormula__c).Tipo_Inventario__c;
                String sVin = mapIdExtCodMod.get(objDodo.TAM_DummyVINFormula__c).Name;
                String sVinPaso = sVin.right(6);
                String sVinFinal;
                String sVinDod = objDodo.TAM_VIN__c != null ? objDodo.TAM_VIN__c  : null;
                String sVinDodPaso;
                Boolean blnmActVin = false;
                //Tiene algo sVinDod               
                if (sVinDod != null){
                    sVinDodPaso = sVinDod.right(6);
                    if (!sVinDodPaso.isNumeric())
                        blnmActVin = true;
                    else
                        sVinFinal = sVin;                    
                } //Fin si sVinDod != null
                //Ve si son numeros en  sPasoDummyVin
                if (sVinPaso.isNumeric() && blnmActVin)
                    sVinFinal = sVin;
                    
                System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler actualizaDod sTipoInv: ' + sTipoInv + ' sVinFinal: ' + sVinFinal);
                //Ve si el TAM_Codigo__c corresponde a mapIdExtCodMod.get(objDodo.TAM_DummyVin__c)
                if (objDodo.TAM_Codigo__c == mapIdExtCodMod.get(objDodo.TAM_DummyVINFormula__c).Model_Number__c){
                    //Crear el objeto del tipo TAM_DODSolicitudesPedidoEspecial__c
                    TAM_DODSolicitudesPedidoEspecial__c objPasoDoD = new TAM_DODSolicitudesPedidoEspecial__c(
                        id = objDodo.id,
                        TAM_TipoInventario__c = sTipoInv,
                        TAM_VIN__c = sVinFinal, 
                        TAM_ModelPhaseCode__c = mapIdExtCodMod.get(objDodo.TAM_DummyVINFormula__c).TAM_ModelPhaseCode__c,
                        TAM_SerialNumberCDig__c = mapIdExtCodMod.get(objDodo.TAM_DummyVINFormula__c).TAM_SerialNumberCDig__c
                    );
                    //if (sVinFinal != null && objPasoDoD.TAM_Estatus__c != 'Cancelado')
                    //    objPasoDoD.TAM_Estatus__c = 'Asignado';
                    //Metelo al mapa de
                    mapIdDodObj.put(objDodo.id, objPasoDoD); 
                }//Fin si objDodo.TAM_Codigo__c == mapIdExtCodMod.get(objDodo.TAM_DummyVin__c)
            }//Fin si mapIdExtCodMod.containsKey(objDodo.TAM_DummyVin__c)
        }//Fin del for para TAM_DODSolicitudesPedidoEspecial__c
        System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler actualizaDod mapIdDodObj: ' + mapIdDodObj);
        System.debug('ENTRO TAM_InventarioVehiculosToyotaTgrHandler actualizaDod mapIdDodObj: ' + mapIdDodObj);
        
        //Ve si tiene algo mapIdDodObj y actueliza
        if (!mapIdDodObj.isEmpty()){
            //Actualiza las Opp 
            List<Database.SaveResult> lDtbUpsRes = Database.update(mapIdDodObj.values(), false);
            //Ve si hubo error
            for (Database.Saveresult objDtbUpsRes : lDtbUpsRes){
                if (!objDtbUpsRes.isSuccess())
                    System.debug('Hubo error a la hora de crear/Actualizar el TAM_DODSolicitudesPedidoEspecial__c desde TAM_InventarioVehiculosToyota__c Error: ' + objDtbUpsRes.getErrors()[0].getMessage());
            }//Fin del for para lDtbUpsRes
        }//Fin si !mapIdDodObj.isEmpty()
        
    }    

    /*//Metodo para cancelar las ventas espaciales que cambiaron de tipo de venta y de cliente
    private void cancelaVentaEspacial(List<TAM_InventarioVehiculosToyota__c> lstVehiculos){
        System.debug('EN TAM_InventarioVehiculosToyotaTgrHandler.cancelaVentaEspacial...');     
        
        Date dFechaCancelaFinal = Date.today();
        List<TAM_LogsErrores__c> lError = new List<TAM_LogsErrores__c>();        
        Map<String, TAM_InventarioVehiculosToyota__c> vines = new Map<String, TAM_InventarioVehiculosToyota__c>();
        Map<String, TAM_CheckOutDetalleSolicitudCompra__c> mapVinCheckout = new Map<String, TAM_CheckOutDetalleSolicitudCompra__c>();
        Map<String, TAM_LeadInventarios__c> mapLeadInvUpd = new Map<String, TAM_LeadInventarios__c>();
        Map<String, List<Movimiento__c>> mapVinLstMov = new Map<String, List<Movimiento__c>>();
        Map<String, TAM_CheckOutDetalleSolicitudCompra__c> mapIdCheckoutObjUps = new Map<String, TAM_CheckOutDetalleSolicitudCompra__c>();
        String strRecordTypeId = Schema.SObjectType.Movimiento__c.getRecordTypeInfosByName().get('Movimiento').getRecordTypeId();
        
        for(TAM_InventarioVehiculosToyota__c v: lstVehiculos){
            if (v.Name != null){
                vines.put(v.Name, v);
            }
        }//Fin del for para los vines
        System.debug('EN TAM_InventarioVehiculosToyotaTgrHandler.cancelaVentaEspacial vines: ' + vines.keySet());     
        System.debug('EN TAM_InventarioVehiculosToyotaTgrHandler.cancelaVentaEspacial vines: ' + vines.values());     
        
        //Consulta los mov asociados a los vines vines.keySet()
        for (Movimiento__c objMovPaso : [Select ID, Name, Sale_Date__c, Submitted_Date__c, Submitted_Time__c, VIN__c,  
                Trans_Type__c, Id_Modelo__c, Distribuidor__c, Objetivo_Venta__c, Month__c, Year__c, 
                Qty__c, TAM_FechaEnvForm__c, TAM_ContadorVenta__c, Fleet__c, VIN__r.Name, TAM_CodigoDistribuidorFrm__c
                From Movimiento__c Where RecordTypeId =: strRecordTypeId
                And VIN__r.Name IN :vines.keySet()]){
            //Mete los mov en el mapa de mapVinLstMov
            if (mapVinLstMov.containsKey(objMovPaso.VIN__r.Name))
                mapVinLstMov.get(objMovPaso.VIN__r.Name).add(objMovPaso);            
            if (!mapVinLstMov.containsKey(objMovPaso.VIN__r.Name))
                mapVinLstMov.put(objMovPaso.VIN__r.Name, new List<Movimiento__c>{objMovPaso});
        }
        System.debug('EN TAM_InventarioVehiculosToyotaTgrHandler.cancelaVentaEspacial mapVinLstMov: ' + vines.keySet());     
        System.debug('EN TAM_InventarioVehiculosToyotaTgrHandler.cancelaVentaEspacial mapVinLstMov: ' + vines.values());     
        
        //Consulta todas las solicitudes de Pedido especial asociada a estos vines
        if (!Test.isRunningTest()){
            for (TAM_CheckOutDetalleSolicitudCompra__c objCheckOutPaso : [Select t.id, t.TAM_VIN__c, 
                t.TAM_SolicitudFlotillaPrograma__c, t.TAM_NombreDistribuidor__c, t.TAM_TipoVenta__c 
                From TAM_CheckOutDetalleSolicitudCompra__c t
                Where TAM_EstatusDealerSolicitud__c = 'Cerrada' 
                And TAM_VIN__c != null and TAM_SolicitudFlotillaPrograma__c != null
                And TAM_TipoVenta__c = 'Pedido Especial'
                And TAM_VIN__c IN : vines.keyset()
                ]){
                //Metelo al mapa de mapVinCheckout
                //if ((objCheckOutPaso.TAM_VIN__c != null && objCheckOutPaso.TAM_TipoVenta__c == 'Pedido Especial') || Test.isRunningTest())
                if ((objCheckOutPaso.TAM_VIN__c != null) || Test.isRunningTest())
                    mapVinCheckout.put(objCheckOutPaso.TAM_VIN__c, objCheckOutPaso);
            }//Fin del for para TAM_CheckOutDetalleSolicitudCompra__c
        }//Fin si !Test.isRunningTest()
        if (Test.isRunningTest()){
            for (TAM_CheckOutDetalleSolicitudCompra__c objCheckOutPaso : [Select t.id, t.TAM_VIN__c, 
                t.TAM_SolicitudFlotillaPrograma__c, t.TAM_NombreDistribuidor__c, t.TAM_TipoVenta__c 
                From TAM_CheckOutDetalleSolicitudCompra__c t
                Where TAM_EstatusDealerSolicitud__c = 'Cerrada' 
                And TAM_VIN__c != null and TAM_SolicitudFlotillaPrograma__c != null
                And TAM_VIN__c IN : vines.keyset()
                ]){
                //Metelo al mapa de mapVinCheckout
                if ((objCheckOutPaso.TAM_VIN__c != null && objCheckOutPaso.TAM_TipoVenta__c == 'Pedido Especial') || Test.isRunningTest())
                    mapVinCheckout.put(objCheckOutPaso.TAM_VIN__c, objCheckOutPaso);
            }//Fin del for para TAM_CheckOutDetalleSolicitudCompra__c
        }//Fin si Test.isRunningTest()
        System.debug('EN TAM_InventarioVehiculosToyotaTgrHandler.cancelaVentaEspacial mapVinCheckout: ' + mapVinCheckout.keySet());     
        System.debug('EN TAM_InventarioVehiculosToyotaTgrHandler.cancelaVentaEspacial mapVinCheckout: ' + mapVinCheckout.values());     
        
        //Reorre la lista de vines y obten su ultimo mov
        for (String sVinPaso : vines.keySet()){
            TAM_InventarioVehiculosToyota__c objPasoInvenVehivToyota = vines.get(sVinPaso);
            TAM_CheckOutDetalleSolicitudCompra__c objCheckOutPaso = mapVinCheckout.get(sVinPaso);
            System.debug('EN TAM_InventarioVehiculosToyotaTgrHandler.cancelaVentaEspacial objPasoInvenVehivToyota: ' + objPasoInvenVehivToyota);
            System.debug('EN TAM_InventarioVehiculosToyotaTgrHandler.cancelaVentaEspacial objCheckOutPaso: ' + objCheckOutPaso);                                                  
            //Ve si el ultimo mov es un pedido especial y cambio a INVENTARIO y ademas esta rechazado
            if ( (objPasoInvenVehivToyota.TAM_Fleet__c == 'N' && objCheckOutPaso.TAM_NombreDistribuidor__c != objPasoInvenVehivToyota.Dealer_Code__c)
                || Test.isRunningTest()){
                //Agregalo al mapa de mapIdCheckoutObjUps 
                TAM_CheckOutDetalleSolicitudCompra__c objCheckOutPasoUpd = new TAM_CheckOutDetalleSolicitudCompra__c(
                    Id = objCheckOutPaso.id, TAM_ListaParaCancelar__c = true,
                    TAM_EstatusDealerSolicitud__c = 'Cancelada',
                    TAM_FechaCancelacion__c = dFechaCancelaFinal,
                    TAM_VIN__c = objCheckOutPaso.TAM_VIN__c
                );
                System.debug('EN TAM_InventarioVehiculosToyotaTgrHandler.cancelaVentaEspacial objCheckOutPasoUpd: ' + objCheckOutPasoUpd);
                //Agregar el objeto al mapa de mapIdCheckoutObjUps
                mapIdCheckoutObjUps.put(objCheckOutPaso.id, objCheckOutPasoUpd);
                //Crea el registro en el log de errores                
                lError.add(new TAM_LogsErrores__c(TAM_idExtReg__c= objCheckOutPaso.id + '-' + objCheckOutPaso.TAM_VIN__c, TAM_VIN__c = objCheckOutPaso.TAM_VIN__c, TAM_Proceso__c = 'Cancelada CheckOut Pedio Especial Cambio Fleet Inventario', TAM_Fecha__c = Date.today(), TAM_DetalleError__c = 'ObjCheckOut: ' + objCheckOutPaso + ' ObjInventVehiToyo: ' + objPasoInvenVehivToyota) );            
            }//Fin si (objPasoInvenVehivToyota.TAM_Fleet__c == 'N' && objCheckOutPaso.TAM_NombreDistribuidor__c != objPasoInvenVehivToyota.Dealer_Code__c)
        
        }//Fin del for para vines.keySet()
        System.debug('EN TAM_InventarioVehiculosToyotaTgrHandler.cancelaVentaEspacial mapIdCheckoutObjUps: ' + mapIdCheckoutObjUps.keyset());
        System.debug('EN TAM_InventarioVehiculosToyotaTgrHandler.cancelaVentaEspacial mapIdCheckoutObjUps: ' + mapIdCheckoutObjUps.values());
        System.debug('EN TAM_InventarioVehiculosToyotaTgrHandler.cancelaVentaEspacial lError: ' + lError);
    
        //Un objeto del tipo Savepoint
        Savepoint sp = Database.setSavepoint();        
        
        //Ve si tiene algo la lista de mapCheckOutDDUps
        if (!mapIdCheckoutObjUps.isEmpty()){
            //Recorre la lista de Opp y busca el VIN para asociar el id de la cuenta en AccountId
            List<Database.Upsertresult> lDtbUpsRes = Database.upsert(mapIdCheckoutObjUps.values(), TAM_CheckOutDetalleSolicitudCompra__c.id, false);
            //Ve si hubo error
            for (Database.Upsertresult objDtbUpsRes : lDtbUpsRes){
                if (!objDtbUpsRes.isSuccess())
                    System.debug('EN TAM_InventarioVehiculosToyotaTgrHandler.cancelaVentaEspacial Hubo un error a la hora de crear/Actualizar los registros en Checkout ERROR: ' + objDtbUpsRes.getErrors()[0].getMessage());
            }//Fin del for para lDtbUpsRes
        }//Fin si !mapCheckOutDDUps.isEmpty()

        //Crea los reg en el objeto de Log
        if (!lError.isEmpty())
            List<Database.Upsertresult> lCheckoutDtbUpsRes = Database.upsert(lError, TAM_LogsErrores__c.TAM_idExtReg__c, false);

        //Roleback a todo
        //Database.rollback(sp);
        
    }*/
    
}